/* AMX Mod script. 
* 
* (c) Copyright 2002-2003, OLO 
* This file is provided as is (no warranties). 
* 
* With small edition of rstrflags var you can 
* make it compatible with CS 1.6 (remember to add 3 new weapons) 
* 
* Plugin doesn't cooperate with Weapon Restriction (console version). 
* If you are using both of these plugins then in order to 
* buy the weapon you must remove restriction in both plugins. 
* 
*/ 

#include <amxmod> 
#include <amxmisc> 

new menuposition[33] 
new modified 
new blockpos[56][3] 
new filetosave[] = "addons/amx/weaprest.ini" 

#define MAXWEAPONS 31

new rstrflags[MAXWEAPONS][3] = { 
{6,0,0}, 
{6,1,0}, 
{6,2,0}, 
{6,3,0}, 
{6,4,0}, 
{6,5,0}, 
{6,6,0}, 
{0,5,0}, 
{0,6,0},  

{1,0,0}, 
{1,1,0},  
{1,2,0}, 
{1,3,0},  
{1,4,0}, 
{1,5,0}, 
  
{2,0,0}, 
{2,1,0}, 

{3,0,0}, 
{3,1,2},  
{3,2,0}, 
{3,3,1}, 
{3,4,0}, 

{4,0,1}, 
{4,1,1},  
{4,2,2}, 
{4,3,2}, 

{4,4,0}, 
{4,5,0}, 
{4,6,1}, 
{4,7,2}, 

{5,0,0} 
} 

new rstrweapons[MAXWEAPONS][] = { 
   "\yEquipment^n\w^n%d. Kevlar Vest\y\R%s^n\w", 
   "%d. Kevlar Vest & Helmet\y\R%s^n\w", 
   "%d. Flashbang\y\R%s^n\w", 
   "%d. HE Grenade\y\R%s^n\w", 
   "%d. Smoke Grenade\y\R%s^n\w", 
   "%d. Defuse Kit\y\R%s^n\w", 
   "%d. NightVision Goggles\y\R%s^n\w" , 
   "%d. Primary weapon ammo\y\R%s^n\w", 
   "%d. Secondary weapon ammo\y\R%s^n\w^n", 

   "\yHandgun^n\w^n%d. H&K USP .45 Tactical\y\R%s^n\w", 
   "%d. Glock18 Select Fire\y\R%s^n\w", 
   "%d. Desert Eagle .50AE\y\R%s^n\w", 
   "%d. SIG P228\y\R%s^n\w", 
   "%d. Dual Beretta 96G Elite\y\R%s^n\w", 
   "%d. FN Five-Seven\y\R%s^n\w^n", 

   "\yShotgun^n\w^n%d. Benelli M3 Super90\y\R%s^n\w", 
   "%d. Benelli XM1014\y\R%s^n\w^n", 
    
   "\ySub-Machine Gun^n\w^n%d. H&K MP5-Navy\y\R%s^n\w", 
   "%d. Steyr Tactical Machine Pistol\y\R%s^n\w", 
   "%d. FN P90\y\R%s^n\w", 
   "%d. Ingram MAC-10\y\R%s^n\w", 
   "%d. H&K UMP45\y\R%s^n\w^n", 
    
   "\yAssault Rifle^n\w^n%d. AK-47\y\R%s^n\w", 
   "%d. Sig SG-552 Commando\y\R%s^n\w", 
   "%d. Colt M4A1 Carbine\y\R%s^n\w", 
   "%d. Steyr Aug\y\R%s^n\w^n", 
    
   "\ySniper Rifle^n\w^n%d. Steyr Scout\y\R%s^n\w", 
   "%d. AI Arctic Warfare/Magnum\y\R%s^n\w", 
   "%d. H&K G3/SG-1 Sniper Rifle\y\R%s^n\w", 
   "%d. Sig SG-550 Sniper\y\R%s^n\w^n", 

   "\yMachine Gun^n\w^n%d. FN M249 Para\y\R%s^n\w" 
} 

public plugin_init(){ 
   register_plugin("Restrict Weapons","0.9.4","default") 
   register_clcmd("buyammo1","ammo1rest") 
   register_clcmd("buyammo2","ammo2rest") 
   register_clcmd("amx_restmenu","cmdMenu",ADMIN_CFG,"- display weapon restriction menu") 
   register_menucmd(register_menuid("\yRestrict Weapons"),1023,"actionMenu") 
   register_menucmd(register_menuid("#Buy", 1 ),511,"menu_buy") 
   register_menucmd(register_menuid("BuyPistol", 1 ),511,"menu_pistol") 
   register_menucmd(register_menuid("BuyShotgun", 1 ),511,"menu_shotgun") 
   register_menucmd(register_menuid("BuySub", 1 ),511,"menu_sub") 
   register_menucmd(register_menuid("BuyRifle", 1 ),511,"menu_rifle") 
   register_menucmd(register_menuid("BuyMachine", 1 ),511,"menu_machine") 
   register_menucmd(register_menuid("BuyItem", 1 ),511,"menu_item") 
   register_menucmd(-28,511,"menu_buy" ) 
   register_menucmd(-29,511,"menu_pistol" ) 
   register_menucmd(-30,511,"menu_shotgun") 
   register_menucmd(-32,511,"menu_sub") 
   register_menucmd(-31,511,"menu_rifle") 
   register_menucmd(-33,511,"menu_machine") 
   register_menucmd(-34,511,"menu_item") 
    
   load_settings(filetosave) 
   return PLUGIN_CONTINUE 
} 

displayMenu(id,pos){ 
   if (pos < 0) return 
   new menubody[512], b, c, k = 0, start = pos * 7 
   if (start >= MAXWEAPONS) start = pos = menuposition[id] = 0 
   new len = format(menubody,511,"\yRestrict Weapons\R%d/5^n\w^n",pos+1) 
   new end = start + 7, keys = (1<<9)|(1<<7) 
   if (end > MAXWEAPONS) end = 31 
   for(new a = start; a < end; ++a){ 
      keys |= (1<<k) 
      b = rstrflags[a][0]*8+rstrflags[a][1] 
      c = rstrflags[a][2] 
      len += format(menubody[len],511-len,rstrweapons[a],++k,blockpos[b][c]?"ON":"OFF") 
   } 
   len += format(menubody[len],511-len,"^n8. Save settings \y\R%s^n\w",modified?"*":"") 
   if (end != MAXWEAPONS){ 
      len += format(menubody[len],511-len,"^n9. More...^n0. %s", pos ? "Back" : "Exit") 
      keys |= (1<<8) 
   } 
   else {
   	len += format(menubody[len],511-len,"^n0. %s", pos ? "Back" : "Exit") 
   }
   show_menu(id,keys,menubody) 
} 

public actionMenu(id,key){ 
   switch(key){ 
   case 7:   { 
         if (save_settings(filetosave)){ 
            modified = false 
            client_print(id,print_chat,"* Configuration saved successfully") 
         } 
         else 
            client_print(id,print_chat,"* Configuration saving failed!!!") 
         displayMenu(id,menuposition[id]) 
      } 
   case 8: displayMenu(id,++menuposition[id]) 
   case 9: displayMenu(id,--menuposition[id]) 
   default: { 
         new a = menuposition[id]*7+key 
         new b = rstrflags[a][0]*8+rstrflags[a][1] 
         switch(rstrflags[a][2]){ 
         case 0: blockpos[b][0]=blockpos[b][1]=blockpos[b][2]=1-blockpos[b][0] 
         case 1: blockpos[b][1]=1-blockpos[b][1] 
         case 2: blockpos[b][2]=1-blockpos[b][2] 
         } 
         modified = true 
         displayMenu(id,menuposition[id]) 
      } 
   } 
   return PLUGIN_HANDLED 
} 

public cmdMenu(id,level,cid){ 
   if (!cmd_access(id,level,cid,1)) 
      return PLUGIN_HANDLED 
   displayMenu(id,menuposition[id] = 0) 
   return PLUGIN_HANDLED 
} 

checkrest(id,menuid,uteam,key){
	if (blockpos[menuid * 8 + key][uteam]){ 
		engclient_cmd(id,"menuselect","10") 
		client_print(id,print_center,"* This position is restricted *") 
		return PLUGIN_HANDLED 
	} 
	return PLUGIN_CONTINUE 
} 

public ammo1rest(id) return checkrest(id,0,get_user_team(id),5) 
public ammo2rest(id) return checkrest(id,0,get_user_team(id),6) 
public menu_buy(id,key) return checkrest(id,0,get_user_team(id),key) 
public menu_pistol(id,key) return checkrest(id,1,get_user_team(id),key) 
public menu_shotgun(id,key) return checkrest(id,2,get_user_team(id),key) 
public menu_sub(id,key) return checkrest(id,3,get_user_team(id),key) 
public menu_rifle(id,key) return checkrest(id,4,get_user_team(id),key) 
public menu_machine(id,key) return checkrest(id,5,get_user_team(id),key) 
public menu_item(id,key) return checkrest(id,6,get_user_team(id),key) 

save_settings(filename[]){ 
   if (file_exists(filename)) 
      delete_file(filename) 
   new text[256], b 
   if (!write_file(filename,";Generated by Restrict Weapons Plugin. Do not modify!^n;Menu Key Team")) 
      return 0 
   for(new a = 0; a < MAXWEAPONS; ++a){ 
      b = rstrflags[a][0] * 8 + rstrflags[a][1]       
      if ( blockpos[b][ rstrflags[a][2] ] ){ 
         format(text,255,"%d %d %d",rstrflags[a][0],rstrflags[a][1],rstrflags[a][2]) 
         write_file(filename,text) 
      } 
   } 
   return 1 
} 

load_settings(filename[]){ 
   if (!file_exists(filename)) return 0 
   new text[256], menua[4], keya[4], teama[4], a, pos = 0 
   while (read_file(filename,pos++,text,255,a)){ 
      if ( text[0] == ';' ) continue // line is a comment 
      parse(text,menua,3,keya,3,teama,3) 
      a = strtonum(menua) * 8 + strtonum(keya) 
      switch(strtonum(teama)){ 
      case 0: blockpos[a][0]=blockpos[a][1]=blockpos[a][2]=1 
      case 1: blockpos[a][1]=1 
      case 2: blockpos[a][2]=1 
      } 
   } 
   return 1 
} 
